RR_EPGPHasLoaded = true

function RR_ReallyGetEPGPGuildData()
    if IsInGuild() then
        local GuildInfoText = GetGuildInfoText()

        --[[
        -EPGP-
        @DECAY_P:10
        @EXTRAS_P:50
        @MIN_EP:2500
        @BASE_GP:100
        -EPGP-
        --]]

        local string_start, string_end = string.find(GuildInfoText, "%-EPGP%-")
        if string_start ~= nil and string_end ~= nil then
            GuildInfoText = string.sub(GuildInfoText, string_end + 2)

            --[[
            @DECAY_P:10
            @EXTRAS_P:50
            @MIN_EP:2500
            @BASE_GP:100
            -EPGP-
            --]]

            local string_start, string_end = string.find(GuildInfoText, "%-EPGP%-")
            if string_start ~= nil then
                GuildInfoText = string.sub(GuildInfoText, 1, string_start - 2)

                --[[
                @DECAY_P:10
                @EXTRAS_P:50
                @MIN_EP:2500
                @BASE_GP:100
                --]]

                for i = 1, 10 do
                    if GuildInfoText ~= nil then
                        string_start, string_end = string.find(GuildInfoText, "%@+%a+%_%a+%:%d+")
                        if string_start ~= nil then
                            Substring = string.sub(GuildInfoText, string_start, string_end)
                            GuildInfoText = string.sub(GuildInfoText, string_end + 2)
                            if RaidRoll_DB["debug"] == true then RR_Test("Leftover String: " .. GuildInfoText) end

                            --[[
                            Substring
                            @DECAY_P:10
                            --]]

                            --[[
                            RR_GuildInfo
                            @EXTRAS_P:50
                            @MIN_EP:2500
                            @BASE_GP:100
                            --]]

                            string_start, string_end = string.find(Substring, "%@+%a+%_%a+%:")
                            Type = string.upper(string.sub(Substring, string_start + 1, string_end - 1))
                            if RaidRoll_DB["debug"] == true then RR_Test("Type: " .. Type) end

                            -- DECAY_P

                            string_start, string_end = string.find(Substring, "%:%d+")
                            Value = tonumber(string.sub(Substring, string_start + 1, string_end))
                            if RaidRoll_DB["debug"] == true then RR_Test("Value: " .. Value) end

                            -- 10

                            RaidRoll_DB[Type] = Value
                        end
                    end
                end
            end
        end
    end
end

function RR_GetGuildOfficerNote(name)
    if IsInGuild() then
        for i = 1, GetNumGuildMembers() do
            local fullName, _, _, _, _, _, _, officerNote = GetGuildRosterInfo(i)  -- Additional retvals ignored
            if RR_IsCharacterNameMatch(name, fullName) then
                return strtrim(officerNote or "")  -- cut out [space][tab][return][newline]
            end
        end
    end

    return ""
end

function RR_ReallyGetEPGPCharacterData(playerName)
    local PR, AboveThreshold, EP, GP = 0, false, 0, 0

    if playerName ~= nil and IsInGuild() then

        RR_GetEPGPGuildData()

        local officerNote = RR_GetGuildOfficerNote(playerName)
        if officerNote ~= "" then

            -- Got a non-empty officer note, so check for EP,GP v main name
            local maybeEP, maybeGP = strsplit(",", officerNote)
            maybeEP = tonumber(maybeEP)
            maybeGP = tonumber(maybeGP)
            if maybeEP ~= nil and maybeGP ~= nil then
                -- Is EP,GP
                EP = maybeEP
                GP = maybeGP
            else

                -- Not EP,GP so check for main name if enabled
                if RaidRoll_DBPC[UnitName("player")]["RR_RollCheckBox_Enable_Alt_Mode"] == true then
                    officerNote = RR_GetGuildOfficerNote(officerNote)
                    if officerNote ~= "" then

                        -- Found main's officer note, so parse out what may be EP,GP
                        maybeEP, maybeGP = strsplit(",", officerNote)
                        maybeEP = tonumber(maybeEP)
                        maybeGP = tonumber(maybeGP)
                        if maybeEP ~= nil and maybeGP ~= nil then
                            -- Is EP,GP
                            EP = maybeEP
                            GP = maybeGP
                        end
                    end
                end
            end

            -- Calculate values for player found in guild
            GP = GP + RaidRoll_DB["BASE_GP"]
            PR = (ceil(EP / GP * 100) / 100)
            if EP >= RaidRoll_DB["MIN_EP"] then AboveThreshold = true end
            if RaidRoll_DB["debug"] == true then RR_Test(name .. ": EP=" .. EP .. " GP=" .. GP .. " PR=" .. PR) end
        end
    end

    return PR, AboveThreshold, EP, GP
end
